;;
;; mailman3.scm
;;
;; Mailman management interface - Mailman version 3.x support
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit mailman3))

(module
 mailman3
 (
  list-mailman3-lists
  )

 (import scheme
	 (chicken string)
	 configuration
	 util-io)

 ;; Runs the mailman3 binary with any arguments and returns the lines
 ;; produced on stdout
 (define (get-mailman3-output-lines . args1)
   (let* ((cmd+args0 (string-split (*mailman3-bin*) " "))
	  (cmd (car cmd+args0))
	  (args0 (cdr cmd+args0)))
     (apply
      get-process-output-lines
      cmd
      (append args0 args1))))

 ;; Returns the list of available lists
 (define (list-mailman3-lists)
   (get-mailman3-output-lines "lists -q"))

 )
